<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/copy_dir_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>12/08/88  copy_dir_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>Copies a subtree from one point in the hierarchy to another, and
<span id="L5" class="LineNr">  5 </span>optionally deletes the source subtree.
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>Entry points in copy_dir_:
<span id="L9" class="LineNr">  9 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>:Entry:  copy_dir_:  12/08/88  copy_dir_
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>Function:
<span id="L16" class="LineNr"> 16 </span>Copies a subtree from one point in the hierarchy to another, and
<span id="L17" class="LineNr"> 17 </span>optionally deletes the source subtree.
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>Syntax:
<span id="L21" class="LineNr"> 21 </span>dcl copy_dir_ entry<span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed
<span id="L22" class="LineNr"> 22 </span>     bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>call copy_dir_ <span class="textRainbow_lv0_p0">(</span>caller<span class="textRainbow_lv0_o0">,</span> source_dir<span class="textRainbow_lv0_o0">,</span> source_ename<span class="textRainbow_lv0_o0">,</span> target_dir<span class="textRainbow_lv0_o0">,</span>
<span id="L24" class="LineNr"> 24 </span>     target_ename<span class="textRainbow_lv0_o0">,</span> pcopy_dir_options<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>Arguments:
<span id="L28" class="LineNr"> 28 </span>caller
<span id="L29" class="LineNr"> 29 </span>   is the name of the calling procedure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L30" class="LineNr"> 30 </span>source_dir
<span id="L31" class="LineNr"> 31 </span>   is the pathname of the source directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L32" class="LineNr"> 32 </span>source_ename
<span id="L33" class="LineNr"> 33 </span>   is the source entry name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>target_dir
<span id="L35" class="LineNr"> 35 </span>   is the pathname of the target directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L36" class="LineNr"> 36 </span>
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>target_ename
<span id="L39" class="LineNr"> 39 </span>   is the target entry name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L40" class="LineNr"> 40 </span>pcopy_dir_options
<span id="L41" class="LineNr"> 41 </span>   is a pointer to the copy_dir_options structure shown below under
<span id="L42" class="LineNr"> 42 </span>   &quot;Info Structure&quot;.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L43" class="LineNr"> 43 </span>code
<span id="L44" class="LineNr"> 44 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L45" class="LineNr"> 45 </span>
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>Info structure:
<span id="L48" class="LineNr"> 48 </span>The following structure is declared in copy_dir_options.incl.pl1:
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>   dcl 1 copy_dir_options        aligned based<span class="textRainbow_lv0_p0">(</span>pcopy_dir_options<span class="textRainbow_lv0_p0">)</span>,
<span id="L51" class="LineNr"> 51 </span>         2 version               fixed bin,
<span id="L52" class="LineNr"> 52 </span>         2 entry_control         aligned,
<span id="L53" class="LineNr"> 53 </span>           3 link                bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L54" class="LineNr"> 54 </span>           3 seg                 bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L55" class="LineNr"> 55 </span>           3 dir                 bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L56" class="LineNr"> 56 </span>           3 msf                 bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L57" class="LineNr"> 57 </span>           3 nnlk                bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L58" class="LineNr"> 58 </span>           3 pad1                bit<span class="textRainbow_lv0_p0">(</span>31<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L59" class="LineNr"> 59 </span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>         2 operation_control     aligned,
<span id="L62" class="LineNr"> 62 </span>           3 delete              bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L63" class="LineNr"> 63 </span>           3 brief               bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L64" class="LineNr"> 64 </span>           3 force               bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L65" class="LineNr"> 65 </span>           3 replace             bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L66" class="LineNr"> 66 </span>           3 update              bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L67" class="LineNr"> 67 </span>           3 acl                 bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L68" class="LineNr"> 68 </span>           3 primary             bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L69" class="LineNr"> 69 </span>           3 link_translation    bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L70" class="LineNr"> 70 </span>           3 chase               bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L71" class="LineNr"> 71 </span>           3 parent_ac_sw        bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L72" class="LineNr"> 72 </span>           3 pad2                bit<span class="textRainbow_lv0_p0">(</span>26<span class="textRainbow_lv0_p0">)</span> unal;
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>   dcl copy_dir_options_version_0 fixed bin init<span class="textRainbow_lv0_p0">(</span>0<span class="textRainbow_lv0_p0">)</span> int static options
<span id="L76" class="LineNr"> 76 </span>        <span class="textRainbow_lv0_p0">(</span>constant<span class="textRainbow_lv0_p0">)</span>;
<span id="L77" class="LineNr"> 77 </span>   dcl pcopy_dir_options         ptr;
<span id="L78" class="LineNr"> 78 </span>
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>   Structure elements:
<span id="L81" class="LineNr"> 81 </span>   version
<span id="L82" class="LineNr"> 82 </span>      is the version number of this structure, currently
<span id="L83" class="LineNr"> 83 </span>      copy_dir_options_version_0.
<span id="L84" class="LineNr"> 84 </span>   link
<span id="L85" class="LineNr"> 85 </span>      if set to &quot;1&quot;b then links are copied.
<span id="L86" class="LineNr"> 86 </span>   seg
<span id="L87" class="LineNr"> 87 </span>      if set to &quot;1&quot;b then segments are copied.
<span id="L88" class="LineNr"> 88 </span>   dir
<span id="L89" class="LineNr"> 89 </span>      if set to &quot;1&quot;b then inferior directories are copied.  If this is
<span id="L90" class="LineNr"> 90 </span>      not set then the subtree is not walked.
<span id="L91" class="LineNr"> 91 </span>   msf
<span id="L92" class="LineNr"> 92 </span>      if set to &quot;1&quot;b then multisegment-files are copied.
<span id="L93" class="LineNr"> 93 </span>   nnlk
<span id="L94" class="LineNr"> 94 </span>      if set to &quot;1&quot;b then non-null links are copied.
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>   pad1
<span id="L98" class="LineNr"> 98 </span>      is unused and must be zero.
<span id="L99" class="LineNr"> 99 </span>   delete
<span id="L100" class="LineNr">100 </span>      if set to &quot;1&quot;b then the source_dir is deleted after the copying
<span id="L101" class="LineNr">101 </span>      is complete.
<span id="L102" class="LineNr">102 </span>   brief
<span id="L103" class="LineNr">103 </span>      if set to &quot;1&quot;b suppresses the printing of warning messages such
<span id="L104" class="LineNr">104 </span>      as &quot;Bit count is inconsistent with current length&quot; and &quot;Current
<span id="L105" class="LineNr">105 </span>      length is not the same as records used&quot;.
<span id="L106" class="LineNr">106 </span>   force
<span id="L107" class="LineNr">107 </span>      if set to &quot;1&quot;b executes, when target_dir already exists, without
<span id="L108" class="LineNr">108 </span>      asking the user.  If force is not set, the user is queried.
<span id="L109" class="LineNr">109 </span>
<span id="L110" class="LineNr">110 </span>
<span id="L111" class="LineNr">111 </span>   replace
<span id="L112" class="LineNr">112 </span>      if set to &quot;1&quot;b deletes the existing contents of target_dir before
<span id="L113" class="LineNr">113 </span>      the copying begins.  If target_dir is non-existent or empty, this
<span id="L114" class="LineNr">114 </span>      control argument has no effect.  The default is to append the
<span id="L115" class="LineNr">115 </span>      contents of source_dir to the existing contents of target_dir.
<span id="L116" class="LineNr">116 </span>      Setting of replace conflicts with the setting of update, and
<span id="L117" class="LineNr">117 </span>      error_table_$inconsistent is returned.
<span id="L118" class="LineNr">118 </span>   update
<span id="L119" class="LineNr">119 </span>      if set to &quot;1&quot;b causes copying of only those entries in source_dir
<span id="L120" class="LineNr">120 </span>      that have comparable entries in target_dir.  Setting of update
<span id="L121" class="LineNr">121 </span>      conflicts with the setting of replace, and
<span id="L122" class="LineNr">122 </span>      error_table_$inconsistent is returned.
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>   acl
<span id="L126" class="LineNr">126 </span>      if set to &quot;1&quot;b gives the ACL on the source_dir entry to its copy
<span id="L127" class="LineNr">127 </span>      in target_dir.  Although initial ACLs are still copied, they are
<span id="L128" class="LineNr">128 </span>      not used in setting the ACL of the new entries when not set.
<span id="L129" class="LineNr">129 </span>   primary
<span id="L130" class="LineNr">130 </span>      if set to &quot;1&quot;b only primary names are copied.  If not set, all
<span id="L131" class="LineNr">131 </span>      the names of the selected entries are copied.
<span id="L132" class="LineNr">132 </span>   link_translation
<span id="L133" class="LineNr">133 </span>      if set to &quot;1&quot;b then links will be translated.  If there are
<span id="L134" class="LineNr">134 </span>      references to the source directory in the link pathname of a link
<span id="L135" class="LineNr">135 </span>      being copied, the link pathname is changed to refer to the target
<span id="L136" class="LineNr">136 </span>      directory.
<span id="L137" class="LineNr">137 </span>   chase
<span id="L138" class="LineNr">138 </span>      if set to &quot;1&quot;b copies the target of a link.  Chasing links
<span id="L139" class="LineNr">139 </span>      eliminates link translation.
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>
<span id="L142" class="LineNr">142 </span>   parent_ac_sw
<span id="L143" class="LineNr">143 </span>      if set to &quot;1&quot;b when target directories need creating.  The access
<span id="L144" class="LineNr">144 </span>      class of the target_dir is obtained from the target's parent
<span id="L145" class="LineNr">145 </span>      directory.  Otherwise, the access class is determined from the
<span id="L146" class="LineNr">146 </span>      source_dir.  This switch may be used by privileged applications
<span id="L147" class="LineNr">147 </span>      to make a downgraded copy of an upgraded hierarchy.  The caller
<span id="L148" class="LineNr">148 </span>      must have previously set the seg and dir AIM privileges in order
<span id="L149" class="LineNr">149 </span>      to read the contents to the upgraded hierarchy.
<span id="L150" class="LineNr">150 </span>   pad2
<span id="L151" class="LineNr">151 </span>      is unused and must be zero.
<span id="L152" class="LineNr">152 </span>
<span id="L153" class="LineNr">153 </span>
<span id="L154" class="LineNr">154 </span>Access required:
<span id="L155" class="LineNr">155 </span>Status permission is required for source_dir and all of the directories
<span id="L156" class="LineNr">156 </span>in its tree.  Status permission is required for the directory
<span id="L157" class="LineNr">157 </span>containing source_dir.  Read access is required on all files under
<span id="L158" class="LineNr">158 </span>source_dir.  Append and modify permission are required for the
<span id="L159" class="LineNr">159 </span>directory containing target_dir if target_dir does not exist.  Modify
<span id="L160" class="LineNr">160 </span>and append permission are required on target_dir if it already exists.
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>If acl is not specified, the system default ACLs are added, then the
<span id="L163" class="LineNr">163 </span>initial ACL for the containing directory is applied <span class="textRainbow_lv0_p0">(</span>which may change
<span id="L164" class="LineNr">164 </span>the system supplied ACL<span class="textRainbow_lv0_p0">)</span>.  Initial ACLs are always copied for the
<span id="L165" class="LineNr">165 </span>current ring of execution.
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>
<span id="L168" class="LineNr">168 </span>Notes:  If target_dir already exists and force is not specified, the
<span id="L169" class="LineNr">169 </span>user is so informed and asked if processing should continue.  If
<span id="L170" class="LineNr">170 </span>target_dir is contained in source_dir, an appropriate error message is
<span id="L171" class="LineNr">171 </span>printed and the subroutine returns.
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>If name duplication occurs while appending the source_dir to the
<span id="L174" class="LineNr">174 </span>target_dir and the name duplication is between directories, the user is
<span id="L175" class="LineNr">175 </span>queried whether processing should continue.  If the user answers yes,
<span id="L176" class="LineNr">176 </span>the contents of the directory are copied <span class="textRainbow_lv0_p0">(</span>appended<span class="textRainbow_lv0_p0">)</span> but none of the
<span id="L177" class="LineNr">177 </span>attributes of that directory are copied.  If the answer is no, the
<span id="L178" class="LineNr">178 </span>directory and its subtree is skipped.  If name duplication should occur
<span id="L179" class="LineNr">179 </span>between segments, the user is asked whether to delete the existing one
<span id="L180" class="LineNr">180 </span>in target_dir.
<span id="L181" class="LineNr">181 </span>
<span id="L182" class="LineNr">182 </span>
<span id="L183" class="LineNr">183 </span>If replace is specified or target_dir does not exist, name duplication
<span id="L184" class="LineNr">184 </span>does not occur.
<span id="L185" class="LineNr">185 </span>
<span id="L186" class="LineNr">186 </span>If part of the tree is not copied <span class="textRainbow_lv0_p0">(</span>by specifying a storage system entry
<span id="L187" class="LineNr">187 </span>key<span class="textRainbow_lv0_p0">)</span>, problems with link translation may occur.  If the link target in
<span id="L188" class="LineNr">188 </span>the source_dir tree was in the part of the tree not copied, there may
<span id="L189" class="LineNr">189 </span>be no corresponding entry in the target_dir tree.  Hence, translation
<span id="L190" class="LineNr">190 </span>of the link causes the link to become null.
<span id="L191" class="LineNr">191 </span>
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>If copying a non-empty mailbox requires that the max_length
<span id="L194" class="LineNr">194 </span>characteristic of the source be applied to the target, then the target
<span id="L195" class="LineNr">195 </span>max_length value will take on the default value that was given it when
<span id="L196" class="LineNr">196 </span>created.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
